
ChiliProject - Bug # 500: short operator api filters c and o

Status: Open Priority: Normal
Author: Chris Woerle Category: Issue tracking
Created: 2011-06-30 Assignee: Chris Woerle
Updated: 2011-07-11 Due date:
Remote issue URL:
Affected version: master
Description: an api call with

issues.xml?my_field=cstartingvalue

will be filtered

<pre>
  @@operators = { "="   => :label_equals,
                  "!"   => :label_not_equals,
                  "o"   => :label_open_issues,
                  "c"   => :label_closed_issues,
                  "!*"  => :label_none,
                  "*"   => :label_all,
                  ">="  => :label_greater_or_equal,
                  "<="  => :label_less_or_equal,
                  "<t+" => :label_in_less_than,
                  ">t+" => :label_in_more_than,
                  "t+"  => :label_in,
                  "t"   => :label_today,
                  "w"   => :label_this_week,
                  ">t-" => :label_less_than_ago,
                  "<t-" => :label_more_than_ago,
                  "t-"  => :label_ago,
                  "~"   => :label_contains,
                  "!~"  => :label_not_contains }

</pre>

<pre>
  def add_short_filter(field, expression)
    return unless expression
    parms = expression.scan(/^(c|o|!\*|!|\*)?(.*)$/).first
    add_filter field, (parms[0] || "="), [parms[1] || ""]
  end
</pre>

h3. possible solutions:

* use c= and o= instead.
* add = parameter to the list (will work) and tell everybody to use my_fields==cstartingvalue

History
2011-07-01 03:57 pm - Chris Woerle
- Status changed from Open to Ready for review

I did this as redmine plugin (sorry) :
https://github.com/suung/redmine_short_operators_fix

Should be working, but you may find some issues.

2011-07-02 07:29 pm - Chris Woerle
- Assignee deleted (Chris Woerle)

2011-07-08 09:39 pm - Felix Schäfer
- Category set to Issue tracking

- (deleted custom field) set to master

- Status changed from Ready for review to Open

Chris, I guess I like the @c=@/@o=@ solution better because it doesn't change the API, whereas forcing everyone to use @==@ would only be doable 
in a major ChiliProject release. Could you make a pull request with the updated filter and a few tests?

2011-07-11 08:01 pm - Chris Woerle
Felix, yes, I will do this soon.

Currently I don't have a clean chiliproject base and this will cost me a minute.

2011-07-11 08:01 pm - Chris Woerle
- Assignee set to Chris Woerle
